﻿using C1.WPF.C1Chart3D;
using C1.WPF.Pdf;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Forms;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using C1.WPF.Theming;

namespace WPF_Chart3D_Print
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            System.Windows.Application.Current.Resources.MergedDictionaries.
    Add(C1Theme.GetCurrentThemeResources(new C1.WPF.Theming.BureauBlack.C1ThemeBureauBlack()));

        }

        private void Pdf_Click(object sender, RoutedEventArgs e)
        {
            // use size of visible chart
            var sz = new Size(chart.ActualWidth, chart.ActualHeight);

            using (var file = File.Open("chart.jpeg", FileMode.Create))
            {
                chart.SaveImage(file, ImageFormat.Jpeg);
            }

            C1PdfDocument doc = new C1PdfDocument();
            doc.Compression = CompressionLevel.BestCompression;

            BitmapSource img = ((BitmapSource)GetThumbnail());
            WriteableBitmap wb = new WriteableBitmap(img);
            doc.DrawImage(wb, new Rect(new Point(),doc.PageSize), ContentAlignment.TopCenter, Stretch.Uniform);

            doc.NewPage();

            SaveFileDialog sfd = new SaveFileDialog()
            {
                DefaultExt = "pdf",
                Filter = "Pdf files (*.pdf)|*.pdf",
            };

            if (sfd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                using (var stream = sfd.OpenFile())
                {
                    doc.Save(stream);
                }
            }
        }

        private ImageSource GetThumbnail()
        {
            byte[] buffer = File.ReadAllBytes("chart.jpeg");
            MemoryStream memoryStream = new MemoryStream(buffer);

            BitmapImage bitmap = new BitmapImage();
            bitmap.BeginInit();
            bitmap.StreamSource = memoryStream;
            bitmap.EndInit();
            bitmap.Freeze();

            return bitmap;
        }

        private void ColorPalette_Click(object sender, RoutedEventArgs e)
        {
            IList<Color> list = new List<Color>();
            //Add the colors as per your requirement  
            list.Add(Colors.DarkGreen);
            list.Add(Colors.DarkOrange);
            list.Add(Colors.DarkViolet);
            list.Add(Colors.HotPink);
            list.Add(Colors.BurlyWood);
            list.Add(Colors.MediumSpringGreen);
            chart.ColorPalette = list;
        }

        private void Prn_Click(object sender, RoutedEventArgs e)
        {
            var dlg = new System.Windows.Controls.PrintDialog();
            if (dlg.ShowDialog().Value)
            {
                dlg.PrintVisual(chart, "ComponentOne Chart3D for WPF");
            }
        }

       
    }
}
